/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.admin.ui.action;

import org.wso2.solutions.identity.admin.ClaimsAdmin;
import org.wso2.solutions.identity.persistence.dataobject.ClaimDO;

import com.opensymphony.xwork2.ActionSupport;

public class EditClaimMappingAction extends ActionSupport {

    private static final long serialVersionUID = 3721582033171664860L;

    private String claimUri;

    private String attrId;

    public String execute() throws Exception {

        ClaimsAdmin admin = new ClaimsAdmin();
        ClaimDO claimDO = admin.findClaimByURI(claimUri);
        claimDO.setAttrId(attrId);
        admin.updateClaim(claimDO);

        return SUCCESS;
    }

    public void setClaimUri(String claimUri) {
        this.claimUri = claimUri;
    }

    public void setAttrId(String attrId) {
        this.attrId = attrId;
    }

}
