/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.admin.ui.action;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.wso2.solutions.identity.admin.ClaimsAdmin;
import org.wso2.solutions.identity.persistence.dataobject.DialectDO;

public class ShowClaimsAction extends ManagedAction {

    private static final long serialVersionUID = 8739996362847999381L;

    private List dialects = new ArrayList();
    
    private List attributeIds = new ArrayList();

    public String execute() throws Exception {

        ClaimsAdmin claimsAdmin = new ClaimsAdmin();
        DialectDO[] dialectDOs = claimsAdmin.getAllDialects();
        dialects = Arrays.asList((DialectDO[]) dialectDOs);
              
        this.loadMessages();
        return SUCCESS;
    }

    public List getDialects() {
        return dialects;
    }

    public List getAttributeIds() {
        return attributeIds;
    }

    public void setAttributeIds(List attributeIds) {
        this.attributeIds = attributeIds;
    }
    
    
}
