/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.admin.ui.action;

import java.util.ArrayList;
import java.util.List;

import org.wso2.solutions.identity.UserStore;
import org.wso2.solutions.identity.admin.ClaimsAdmin;
import org.wso2.solutions.identity.persistence.dataobject.ClaimDO;
import org.wso2.solutions.identity.users.IdentityDefaultRealm;;

public class ShowEditClaimMappingAction
        extends ManagedAction {

    private static final long serialVersionUID = 4119087927609325024L;

    private String claimUri = null;

    private String claimMapping = null;

    private List attributeIds = new ArrayList();

    public String execute() throws Exception {

        if (this.claimUri == null || claimUri.trim().length() == 0) {
            return ERROR;
        }

        ClaimsAdmin admin = new ClaimsAdmin();
        ClaimDO claimDO = admin.findClaimByURI(this.claimUri);
        if (claimDO == null) {
            return ERROR;
        }

        this.claimMapping = claimDO.getAttrId();

        UserStore connector = UserStore.getInstance();
        if (connector.getRealm().getClass().getName().equals(
                IdentityDefaultRealm.class.getName())) {
            this.attributeIds.add(claimUri);
        } else {
            // Get available attr IDs
            this.attributeIds = UserStore.getInstance().getPropertyNames();
        }

        return SUCCESS;
    }

    public String getClaimUri() {
        return claimUri;
    }

    public String getClaimMapping() {
        return claimMapping;
    }

    public List getAttributeIds() {
        return attributeIds;
    }

    public void setClaimUri(String claimUri) {
        this.claimUri = claimUri;
    }

    public void setClaimMapping(String claimMapping) {
        this.claimMapping = claimMapping;
    }

    public void setAttributeIds(List attributeIds) {
        this.attributeIds = attributeIds;
    }
    
    
}
