/*
 * Copyright 2005-2008 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.sts.saml;

import org.apache.rahas.RahasData;
import org.opensaml.saml2.core.Attribute;
import org.opensaml.saml2.core.AttributeStatement;
import org.opensaml.saml2.core.AttributeValue;
import org.opensaml.xml.Configuration;
import org.opensaml.xml.XMLObjectBuilderFactory;
import org.opensaml.xml.schema.XSAny;
import org.opensaml.xml.schema.impl.XSAnyBuilder;
import org.wso2.solutions.identity.IdentityProviderException;
import org.wso2.solutions.identity.sts.IdentityProviderData;

public class SAML2TokenBuilderSimulator
        extends SAML2TokenBuilder {

    public void createStatement(IdentityProviderData ipData, RahasData rahasData)
            throws IdentityProviderException {

        attributeStmt = (AttributeStatement) buildXMLObject(AttributeStatement.DEFAULT_ELEMENT_NAME);

        String uri = "http://www.test.dialect/name";
        int index = uri.lastIndexOf("/");
        String attrName = uri.substring(index + 1, uri.length());
        String attrNamespace = uri.substring(0, index);

        Attribute attribute = (Attribute) buildXMLObject(Attribute.DEFAULT_ELEMENT_NAME);
        attribute.setName(attrName);
        attribute.setNameFormat(attrNamespace);

        XMLObjectBuilderFactory builderFactory = Configuration
                .getBuilderFactory();

        XSAnyBuilder attributeValueBuilder = (XSAnyBuilder) builderFactory
                .getBuilder(XSAny.TYPE_NAME);

        XSAny stringValue = attributeValueBuilder.buildObject(
                AttributeValue.DEFAULT_ELEMENT_NAME, null);
        stringValue.setTextContent("test");

        attribute.getAttributeValues().add(stringValue);
        attributeStmt.getAttributes().add(attribute);
        
        
    }

}
