#include <stdio.h>
#include "cspace_debug.h"
#include "process_request.h"
#include "test_self.h"
#include "test_managed.h"

static void sample_set_header_callback(char *ns_uri, char *key, char *val,
                                       void *container, void *cb_ctx);

int main()
{
    cspace_process_context_init();

    process_context_t *ctx = cspace_process_context_create_default();

    cspace_process_context_set_key_file(ctx, "identity.lk.wso2.com.key");
    cspace_process_context_set_ca_file(ctx, "cacert.pem");
    cspace_process_context_set_header_callback(ctx,
                                               sample_set_header_callback ,
                                               NULL);
    if (cspace_process_request(ctx, TEST_TOKEN_MANAGED)) {
        printf("Verificatio SUCCESS!\n\n");
    } else {
        printf("Verificatio FAILED!\n\n");
    }

    cspace_process_context_free(ctx);
    /*ctx = cspace_process_context_create_default();
    
    cspace_process_context_set_key_file(ctx, "samplerp1.key");
    cspace_process_context_set_header_callback(ctx,
                                               sample_set_header_callback ,
                                               NULL);
    if (cspace_process_request(ctx, TEST_TOKEN_SELF)) {
        printf("Verificatio SUCCESS!\n");
    } else {
        printf("Verificatio FAILED!\n");
    }

    cspace_process_context_free(ctx); */
    cspace_process_context_halt();

    return 0;
}

static void sample_set_header_callback(char *ns_uri, char *key, char *val,
                                       void *container, void *cb_ctx)
{
        printf("header: %s, val: %s, uri: %s\n", key, val, ns_uri);
        free(ns_uri); free(key);
        free(val);
}
