package org.wso2.solutions.identity.relyingparty.saml.tokens;

import java.util.Map;

import org.opensaml.xml.io.UnmarshallingException;
import org.opensaml.xml.signature.Signature;
import org.w3c.dom.Element;

public interface TokenHolder {

    /**
     * Creates the SAML object from the element This method must be called first
     * 
     * @param elem
     * @throws UnmarshallingException
     *             If the token creation fails
     */
    public void createToken(Element elem) throws UnmarshallingException;

    /**
     * @return the SAML signature.
     */
    public Signature getSAMLSignature();

    /**
     * Populates the attributes.
     * 
     * @param attributeTable
     */
    public void populateAttributeTable(Map attributeTable);

    /**
     * Issuer of the SAML token
     * 
     * @return
     */
    public String getIssuerName();

}
