/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.user.ui;

/**
 * User interface related constants of the identity provider user web app.
 */
public class UIConstants {

    public final static String USER = "user";

    public final static String PPID = "ppid";

    public final static String LOGIN_ACTION = "Login.action";

    public final static String SHOW_LOGIN_ACTION = "ShowLogin.action";

    public final static String INFOCARD_SUBMIT_ACTION = "InfoCardSubmit.action";

    public final static String USER_REGISTRATION_FORM_ACTION = "ShowUserRegistration.action";

    public final static String USER_REGISTRATION_CARD_ACTION = "InfoCardUserRegistration";

    public final static String USER_REGISTRATION_FORM_SUBMIT_ACTION = "UserRegistrationFormSubmit";

    public final static String USER_REGISTRATION_CARD_SUBMIT_ACTION = "InfoCardUserRegistrationSubmit";

    public final static String LOGIN_JSP = "/jsp/login.jsp";

    public final static String JSP_ERROR_PAGE = "/jsp/error.jsp";

    public final static String CARD_ISSUER_CONFIG_PATH = "WEB-INF/infocard-issuer-config.xml";

    public final static String MAIN_PAGE_MESSAGES = "mainMessages";

    public final static String OPENID_LOGIN_ACTION = "OpenIDLogin.action";

    public final static String OPENID_SUBMIT_ACTION = "OpenIDSubmit.action";

    public final static String OPENDID_CALLBACK_ACTION = "OpenIDCallback.action";

    public final static String OPENID_SERVER_PAGE = "/server";

    public final static String OPENID_USER_PAGE = "/user";
    
    public final static String OPENID_REDIRECT = "/redirect.jsp";    

    public final static String OPENID_AUTH_ACTION = "OpenIDAuthentication.action";

    public final static String OPENID_INFO_CARD__DOWNLOAD_ACTION = "OpenIDDownloadInfoCard.action";

    public final static String OPENID_INFO_CARD__SUBMIT_ACTION = "OpenIDInfoCardSubmit.action";

    public final static String OPENID_AUTH_VERIFICATION_ACTION = "OpenIDAuthVerification.action";

    public final static String OPENID_USER_APPROVAL_ACTION = "OpenIDUserApproval.action";

    public final static String CLAIM_UPDATE_ENABLE = "enable";

    public final static String CLAIM_UPDATE_DISABLE = "disable";

    public final static String UPDATE_OPENID_USER_RP_ACTION = "UpdateOpenIDUserRP.action";

    public final static String ADD_USER_PROFILE_ACTION = "AddUserProfile.action";

    public final static String ADD_USER_PROFILE_SUBMIT_ACTION = "AddUserProfileSubmit.action";

    public final static String EDIT_USER_PROFILE_ACTION = "EditUserProfile.action";
    
    public final static String EDIT_USER_PROFILE_SUBMIT_ACTION = "EditUserProfileSubmit.action"; 
    
    public final static String OPENID_REDIRECT_ACTION="OpenIDRedirect.action";
}
