/*
 * Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.user.ui.action;

import java.util.Map;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts2.StrutsStatics;
import org.wso2.solutions.identity.admin.ReportAdmin;
import org.wso2.solutions.identity.persistence.dataobject.ActionDO;
import org.wso2.solutions.identity.user.ui.UIConstants;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class LogoutAction extends ActionSupport {

    private static final long serialVersionUID = -2506833829058717823L;

    public String execute() throws Exception {

        ActionContext context = null;
        HttpServletRequest request = null;
        HttpServletResponse response = null;

        context = ActionContext.getContext();
        request = (HttpServletRequest) context.get(StrutsStatics.HTTP_REQUEST);
        response = (HttpServletResponse) context
                .get(StrutsStatics.HTTP_RESPONSE);

        Map session = context.getSession();
        String username = (String) session.get(UIConstants.USER);
        session.remove(UIConstants.USER);
        session.remove(UIConstants.PPID);

        // Delete user login cookies on sign-out
        Cookie[] cookies = request.getCookies();

        if (cookies != null) {
            Cookie curCookie = null;
            for (int x = 0; x < cookies.length; x++) {
                curCookie = cookies[x];
                if (curCookie.getName().equalsIgnoreCase("rememberme")) {
                    curCookie.setMaxAge(0);
                    response.addCookie(curCookie);
                } else if (curCookie.getName().equalsIgnoreCase("openid")) {
                    curCookie.setMaxAge(0);
                    response.addCookie(curCookie);
                } else if (curCookie.getName().equalsIgnoreCase("password")) {
                    curCookie.setMaxAge(0);
                    response.addCookie(curCookie);
                }
            }
        }

        String msg = getText("successful_for", new String[] { username });
        ReportAdmin.record(username, ActionDO.ACTION_USER_LOG_OUT, msg);
        return SUCCESS;
    }

}
