/*
 * Copyright 2005-2008 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.user.ui.action;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.StrutsStatics;
import org.wso2.solutions.identity.IdentityConstants;
import org.wso2.solutions.identity.user.ui.UIConstants;
import org.wso2.solutions.identity.user.ui.util.UserUtil;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class OpenIDInfoCardLoginAction extends ActionSupport {

    private static final long serialVersionUID = 6703990413858353723L;

    /**
     * This will get executed during OpenID Information card login
     */
    public String execute() throws Exception {

        ActionContext context = null;
        HttpServletRequest request = null;
        Map map = null;
        String openID = null;
        String userID = null;

        try {
            context = ActionContext.getContext();
            request = (HttpServletRequest) context
                    .get(StrutsStatics.HTTP_REQUEST);
            map = ActionContext.getContext().getSession();

            if (request.getMethod().equals("GET")) {
                return SUCCESS;
            }

            openID = (String) request
                    .getAttribute(IdentityConstants.OpenId.OPENID_IDENTIFIER);

            if (openID == null) {
                return ERROR;
            }

            userID = UserUtil.getUserName(openID);

            // Set the logged in user's id.
            map.put(UIConstants.USER, userID);

        } catch (Exception e) {
            return ERROR;
        }

        return "login";
    }
}