/*
 * Copyright 2005-2008 WSO2, Inc. (http://wso2.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.solutions.identity.user.ui.action;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.struts2.StrutsStatics;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;

public class OpenIDRedirectAction extends ActionSupport {

    /**
     * 
     */
    private static final long serialVersionUID = -1951830854960371602L;

    private Map parameterMap;

    private String destinationUrl;

    /**
     * This will get executed during OpenID login
     */
    public String execute() throws Exception {

        ActionContext context = null;
        HttpServletRequest request = null;
        HttpSession session = null;

        try {
            context = ActionContext.getContext();
            request = (HttpServletRequest) context
                    .get(StrutsStatics.HTTP_REQUEST);
            session = request.getSession();

            parameterMap = (Map) session.getAttribute("parameterMap");
            destinationUrl = (String) session.getAttribute("destinationUrl");

        } catch (RuntimeException e) {
            return ERROR;
        } finally {

            if (session != null) {
                session.removeAttribute("parameterMap");
                session.removeAttribute("destinationUrl");
            }
        }

        return SUCCESS;
    }

    public Map getParameterMap() {
        return parameterMap;
    }

    public void setParameterMap(Map parameterMap) {
        this.parameterMap = parameterMap;
    }

    public String getDestinationUrl() {
        return destinationUrl;
    }

    public void setDestinationUrl(String destinationUrl) {
        this.destinationUrl = destinationUrl;
    }

}
